<?php

//config
$debug = false;

//global variables
$fc=0;//file count
$fa=0;//frames all
$fe=0;//frames with error

//input parameter check
if($argc<2){//logged communication file shall be the first parameter
  echo "Log file parameter is missing!\n";
  exit;
}

//Main task
foreach($argv as $idx => $file){
  if($idx<1)continue;//do from first real parameter only
  if(!file_exists($file)){
    echo "Cannot open file '$file'!\n";
    continue;
  }
  $fc++;
  if($debug)echo "\n\nFile '$file'\n";
  foreach(file($file) as $ln => $line){
    $line=trim($line);
    if(0==strlen($line))continue;
    if(false!==strpos($line,"0A"))continue; //frame contains 0x0a is always wrong. Most likely due to wrong handling of new line character of my serial terminal.
    $bytes=explode(" ",$line);
    if(count($bytes) != 8 && count($bytes) != 11 )continue;//frame len is 8 from display to controller, and 11 for the reverse direction.
    $cs = 0;
    for($x=1;$x<(count($bytes)-2);$x++){//skip first frame header byte and last "controll lamps" byte.
      $cs += hexdec(trim($bytes[$x]));
    }
    $cs&=0xFF;//truncate to byte
    $fa++;
    if($debug)echo "In line ".sprintf("%5d",$ln)." '$line'! Calculated ".sprintf("%02X",$cs);
    if($cs != hexdec($bytes[count($bytes)-1])){
      if($debug)echo " error!";
      $fe++;
    }
    if($debug)echo "\n";
  }
}

//Print result
echo "$fa lines were proceeded in $fc files, $fe frames were wrong.\n";



?>
